#include <stdio.h>
#include <math.h>
#include "mpi.h"

/*Function Prologue*/
float f(float x);

int main(int argc, char* argv[])
{
  /*Data Declarations*/
  int   my_rank;	   
  int   p;
  int i;           
  float a= 0;
  float b= 1;
  int   n= 50;
  int count=1;
  float h;
  float total;
  float x;
  int   root=0;
  float integral;
  float fptr[10];
  
  /*Basic MPI functions*/
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
  MPI_Comm_size(MPI_COMM_WORLD, &p);
  MPI_Bcast(&n, count, MPI_INT, root, MPI_COMM_WORLD);
    
  h= (b-a)/n;

  for(i= my_rank+1; i<=n; i+=p)
  {
    x= h* ((float)i-0.5);
    integral+= f(x);
  }
  integral= h*integral;

  MPI_Gather(&integral, count, MPI_FLOAT, fptr, 1, MPI_FLOAT, root, MPI_COMM_WORLD);		

  /*The root processor adds the gathered integrals from all the other
  processes*/
  if(my_rank==0)
   {
      int i;
      total= 0;	

      for(i=0; i<p; i++)
        total= total+fptr[i];
   }

   MPI_Bcast(&total, count, MPI_FLOAT, root, MPI_COMM_WORLD);

   printf("\nValue of PI from process%i: %.15f\n", my_rank, total);    
   
   MPI_Finalize() ;
}

float f(float x)
{	
  return (4.0/(1.0+x*x));
}

